
package de.ivu.elect.sitzberechnung.konflikt;

import static java.util.Collections.emptyList;
import static java.util.stream.Collectors.toList;

import java.util.Collection;
import java.util.List;

import com.google.gson.Gson;

import de.ivu.elect.sitzberechnung.Gebiet;
import de.ivu.elect.sitzberechnung.Gruppe;
import de.ivu.elect.sitzberechnung.Kandidatur;
import de.ivu.elect.sitzberechnung.Liste;
import de.ivu.elect.sitzberechnung.SitzberechnungEntity;

public class ErgebnisKonfliktKandidaturenAuswaehlen extends AbstractErgebnisKonfliktEntitiesAuswaehlen {

  private final List<String> kandidaturKeysAuswaehlbar;

  private final List<String> kandidaturKeysAusgewaehlt;

  private final String gruppeKey;

  private final String listeKey;

  private ErgebnisKonfliktKandidaturenAuswaehlen(String wahlgebietKey, String wahlvorschlaggebietKey, String gruppeKey, String listeKey, Enum< ? > typ, ErgebnisKonfliktStatus ergebnisKonfliktStatus,
      long anzahlAuszuwaehlen, List<String> kandidaturKeysAuswaehlbar, List<String> kandidaturKeysAusgewaehlt) {
    super(wahlgebietKey, wahlvorschlaggebietKey, typ, ergebnisKonfliktStatus, anzahlAuszuwaehlen);

    this.gruppeKey = gruppeKey;
    this.listeKey = listeKey;

    this.kandidaturKeysAuswaehlbar = kandidaturKeysAuswaehlbar;
    this.kandidaturKeysAusgewaehlt = kandidaturKeysAusgewaehlt;
  }

  @Override
  public ErgebnisKonfliktArt getErgebnisKonfliktArt() {
    return ErgebnisKonfliktArt.LOSENTSCHEID_AUSWAHL_KANDIDATUREN;
  }

  public boolean isAuswahlInGruppe() {
    return getGruppeKey() != null && !getGruppeKey().isBlank();
  }

  public String getGruppeKey() {
    return gruppeKey;
  }

  public boolean isAuswahlInListe() {
    return getListeKey() != null && !getListeKey().isBlank();
  }

  public String getListeKey() {
    return listeKey;
  }

  public List<String> getKandidaturKeysAuswaehlbar() {
    return kandidaturKeysAuswaehlbar;
  }

  public List<String> getKandidaturKeysAusgewaehlt() {
    return kandidaturKeysAusgewaehlt;
  }

  @Override
  public boolean isFachlichGleich(ErgebnisKonflikt other) {
    return other instanceof ErgebnisKonfliktKandidaturenAuswaehlen && isFachlichGleich((ErgebnisKonfliktKandidaturenAuswaehlen) other);
  }

  protected boolean isFachlichGleich(ErgebnisKonfliktKandidaturenAuswaehlen other) {
    return super.isFachlichGleich(other) && other.getKandidaturKeysAuswaehlbar().size() == getKandidaturKeysAuswaehlbar().size()
        && other.getKandidaturKeysAuswaehlbar().containsAll(getKandidaturKeysAuswaehlbar());
  }

  public <E extends SitzberechnungEntity> List<E> filterKandidaturenAuswaehlbar(Collection<E> entities) {
    return filterEntitiesByEntityKeys(entities, getKandidaturKeysAuswaehlbar());
  }

  public <E extends SitzberechnungEntity> List<E> filterKandidaturenAusgewaehlt(Collection<E> entities) {
    return filterEntitiesByEntityKeys(entities, getKandidaturKeysAusgewaehlt());
  }

  @Override
  public String toJson() {
    return toJson(this);
  }

  public static String toJson(ErgebnisKonfliktKandidaturenAuswaehlen ergebnisKonflikt) {
    ErgebnisKonfliktEntitiesDaten daten = new ErgebnisKonfliktEntitiesDaten();
    daten.setWahlgebietKey(ergebnisKonflikt.getWahlgebietKey());
    daten.setWahlvorschlaggebietKey(ergebnisKonflikt.getWahlvorschlaggebietKey());
    daten.setGruppeKey(ergebnisKonflikt.getGruppeKey());
    daten.setListeKey(ergebnisKonflikt.getListeKey());
    daten.setLosentscheidTyp(ergebnisKonflikt.getLosentscheidTyp());
    daten.setAnzahlAuszuwaehlen(ergebnisKonflikt.getAnzahlAuszuwaehlen());
    daten.setErgebnisKonfliktStatus(ergebnisKonflikt.getErgebnisKonfliktStatus());
    daten.setKandidaturKeysAuswaehlbar(ergebnisKonflikt.getKandidaturKeysAuswaehlbar());
    daten.setKandidaturKeysAusgewaehlt(ergebnisKonflikt.getKandidaturKeysAusgewaehlt());

    return new Gson().toJson(daten);
  }

  public static ErgebnisKonfliktKandidaturenAuswaehlen fromJson(String json) {
    ErgebnisKonfliktEntitiesDaten daten = new Gson().fromJson(json, ErgebnisKonfliktEntitiesDaten.class);

    if (daten != null && !daten.isEmpty()) {
      return newInstance(daten.getWahlgebietKey(), daten.getWahlvorschlaggebietKey(), daten.getGruppeKey(), daten.getListeKey(), daten.getLosentscheidTyp(), daten.getErgebnisKonfliktStatus(),
          daten.getAnzahlAuszuwaehlen(), daten.getKandidaturKeysAuswaehlbar(), daten.getKandidaturKeysAusgewaehlt());
    }

    return null;
  }

  public static ErgebnisKonfliktKandidaturenAuswaehlen newInstance(Gebiet wahlgebiet, Gebiet wahlvorschlaggebiet, Gruppe gruppe, Liste liste, Enum< ? > typ, long anzahlAuszuwaehlen,
      List<Kandidatur> auswaehlbar) {
    return newInstance(wahlgebiet == null ? "" : wahlgebiet.getKey(), wahlvorschlaggebiet == null ? "" : wahlvorschlaggebiet.getKey(), gruppe == null ? "" : gruppe.getKey(),
        liste == null ? "" : liste.getKey(), typ, ErgebnisKonfliktStatus.UNGELOEST, anzahlAuszuwaehlen, auswaehlbar.stream().map(SitzberechnungEntity::getKey).collect(toList()), emptyList());
  }

  public static ErgebnisKonfliktKandidaturenAuswaehlen newInstance(String wahlgebietKey, String wahlvorschlaggebietKey, String gruppeKey, String listeKey, Enum< ? > typ,
      ErgebnisKonfliktStatus ergebnisKonfliktStatus, long anzahlAuszuwaehlen, List<String> kandidaturKeysAuswaehlbar, List<String> kandidaturKeysAusgewaehlt) {
    return new ErgebnisKonfliktKandidaturenAuswaehlen(wahlgebietKey, wahlvorschlaggebietKey, gruppeKey, listeKey, typ, ergebnisKonfliktStatus, anzahlAuszuwaehlen, kandidaturKeysAuswaehlbar,
        kandidaturKeysAusgewaehlt);
  }
}
